searchNodes=[{"ref":"NotQwerty123.html","title":"NotQwerty123","type":"module","doc":"Library to check password strength and generate random passwords. The NotQwerty123.PasswordStrength module provides checks that the password is not too easy to guess. These checks check that the password is long enough and that it is not similar to any common passwords. The NotQwerty123.RandomPassword module generates a random password with letters, digits and punctuation characters."},{"ref":"NotQwerty123.Gettext.html","title":"NotQwerty123.Gettext","type":"module","doc":""},{"ref":"NotQwerty123.Gettext.html#dgettext/3","title":"NotQwerty123.Gettext.dgettext/3","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#dgettext_noop/2","title":"NotQwerty123.Gettext.dgettext_noop/2","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#dngettext/5","title":"NotQwerty123.Gettext.dngettext/5","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#dngettext_noop/3","title":"NotQwerty123.Gettext.dngettext_noop/3","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#gettext/2","title":"NotQwerty123.Gettext.gettext/2","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#gettext_comment/1","title":"NotQwerty123.Gettext.gettext_comment/1","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#gettext_noop/1","title":"NotQwerty123.Gettext.gettext_noop/1","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#handle_missing_bindings/2","title":"NotQwerty123.Gettext.handle_missing_bindings/2","type":"function","doc":"Default handling for missing bindings. This function is called when there are missing bindings in a translation. It takes a Gettext.MissingBindingsError struct and the translation with the wrong bindings left as is with the %{} syntax. For example, if something like this is called: MyApp.Gettext.gettext(&quot;Hello %{name}, welcome to %{country}&quot;, name: &quot;Jane&quot;, country: &quot;Italy&quot;) and our it/LC_MESSAGES/default.po looks like this: msgid &quot;Hello %{name}, welcome to %{country}&quot; msgstr &quot;Ciao %{name}, benvenuto in %{cowntry}&quot; # (typo) then Gettext will call: MyApp.Gettext.handle_missing_bindings(exception, &quot;Ciao Jane, benvenuto in %{cowntry}&quot;) where exception is a struct that looks like this: %Gettext.MissingBindingsError{ backend: MyApp.Gettext, domain: &quot;default&quot;, locale: &quot;it&quot;, msgid: &quot;Hello %{name}, welcome to %{country}&quot;, bindings: [:country], } The return value of the c:handle_missing_bindings/2 callback is used as the translated string that the translation macros and functions return. The default implementation for this function uses Logger.error/1 to warn about the missing binding and returns the translated message with the incomplete bindings. This function can be overridden. For example, to raise when there are missing bindings: def handle_missing_bindings(exception, _incomplete) do raise exception end Callback implementation for Gettext.Backend.handle_missing_bindings/2."},{"ref":"NotQwerty123.Gettext.html#handle_missing_plural_translation/6","title":"NotQwerty123.Gettext.handle_missing_plural_translation/6","type":"function","doc":"Default handling for plural translations with a missing translation. Same as c:handle_missing_translation/4, but for plural translations. In this case, n is the number used for pluralizing the translated string. Callback implementation for Gettext.Backend.handle_missing_plural_translation/6."},{"ref":"NotQwerty123.Gettext.html#handle_missing_translation/4","title":"NotQwerty123.Gettext.handle_missing_translation/4","type":"function","doc":"Default handling for translations with a missing translation. When a Gettext function/macro is called with a string to translate into a locale but that locale doesn&#39;t provide a translation for that string, this callback is invoked. msgid is the string that Gettext tried to translate. This function should return {:ok, translated} if a translation can be fetched or constructed for the given string, or {:default, msgid} otherwise. Callback implementation for Gettext.Backend.handle_missing_translation/4."},{"ref":"NotQwerty123.Gettext.html#lgettext/4","title":"NotQwerty123.Gettext.lgettext/4","type":"function","doc":""},{"ref":"NotQwerty123.Gettext.html#lngettext/6","title":"NotQwerty123.Gettext.lngettext/6","type":"function","doc":""},{"ref":"NotQwerty123.Gettext.html#ngettext/4","title":"NotQwerty123.Gettext.ngettext/4","type":"macro","doc":""},{"ref":"NotQwerty123.Gettext.html#ngettext_noop/2","title":"NotQwerty123.Gettext.ngettext_noop/2","type":"macro","doc":""},{"ref":"NotQwerty123.PasswordStrength.html","title":"NotQwerty123.PasswordStrength","type":"module","doc":"Module to check password strength. This module does not provide a password strength meter. Instead, it simply rejects passwords that are considered too weak. Depending on the nature of your application, a solid front end solution to password checking, such as this Dropbox implementation might be a better idea. Password strength In simple terms, password strength depends on how long a password is and how easy it is to guess it. In most cases, passwords should be at least 8 characters long, and they should not be similar to common passwords, like password or qwerty123, or consist of repeated characters, like abcabcabcabc. Dictionary words, common names and user-specific words (company name, address, etc.) should also be avoided. Further information The NIST password guidelines. The Comeonin wiki also has links to further information about password-related issues."},{"ref":"NotQwerty123.PasswordStrength.html#strong_password?/2","title":"NotQwerty123.PasswordStrength.strong_password?/2","type":"function","doc":"Check the strength of the password. It returns {:ok, password} or {:error, message} The password is checked to make sure that it is not too short, that it does not consist of repeated characters (e.g. &#39;abcabcabcabc&#39;) and that it is not similar to any word in the common password list. See the documentation for NotQwerty123.WordlistManager for information about customizing the common password list. Options There is one option: :min_length - minimum allowable length of the password default is 8"},{"ref":"NotQwerty123.RandomPassword.html","title":"NotQwerty123.RandomPassword","type":"module","doc":"Module to generate random passwords. Users are often advised to use random passwords for authentication. However, creating truly random passwords is difficult for people to do well and is something that computers are usually better at. This module provides the gen_password function, which generates a random password."},{"ref":"NotQwerty123.RandomPassword.html#gen_password/1","title":"NotQwerty123.RandomPassword.gen_password/1","type":"function","doc":"Generate a random password. Options There are two options: :length - length of the password, in characters the default is 8 the minimum length is 6 :characters - the character set - :letters, :letters_digits or :letters_digits_punc the default is :letters_digits, which will use letters and digits in the password :digits will only use digits :letters will use uppercase and lowercase letters :letters_digits_punc will use letters, digits and punctuation characters"},{"ref":"NotQwerty123.Supervisor.html","title":"NotQwerty123.Supervisor","type":"module","doc":""},{"ref":"NotQwerty123.Supervisor.html#child_spec/1","title":"NotQwerty123.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"NotQwerty123.Supervisor.html#init/1","title":"NotQwerty123.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"NotQwerty123.Supervisor.html#start_link/0","title":"NotQwerty123.Supervisor.start_link/0","type":"function","doc":""},{"ref":"NotQwerty123.WordlistManager.html","title":"NotQwerty123.WordlistManager","type":"module","doc":"Module to manage the common password list and handle password checks. The main function that NotQwerty123 performs is to check that the password or a variant of the password (in other words, even with minor changes) is not in the list of common passwords that this WordlistManager stores. By default, this common password list contains one file, which has a list of over 40,000 common passwords in it - this file was collated by zxcvbn, a reputable password strength meter. Other files can be added to this common password list, and there are example files in the priv/data directory (these files are also taken from the zxcvbn repository). In order to make the password strength check even stronger, it is also recommended to add to the list words that are associated with the site you are managing. Managing the common password list The following functions can be used to manage this list: list_wordlists/0 - list the files used to create the wordlist push/1 - add a file to the wordlist pop/1 - remove a file from the wordlist"},{"ref":"NotQwerty123.WordlistManager.html#child_spec/1","title":"NotQwerty123.WordlistManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"NotQwerty123.WordlistManager.html#init/1","title":"NotQwerty123.WordlistManager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"NotQwerty123.WordlistManager.html#list_files/0","title":"NotQwerty123.WordlistManager.list_files/0","type":"function","doc":"List the files used to create the common password list."},{"ref":"NotQwerty123.WordlistManager.html#pop/1","title":"NotQwerty123.WordlistManager.pop/1","type":"function","doc":"Remove a file from the common password list. path is the file name as it is printed out in the list_files function."},{"ref":"NotQwerty123.WordlistManager.html#push/1","title":"NotQwerty123.WordlistManager.push/1","type":"function","doc":"Add a file to the common password list. path is the pathname of the file, which should contain one password on each line, that you want to include. The file is parsed and the words are added to the common password list. A copy of the file is also copied to the not_qwerty123/priv/wordlists directory. If adding the file results in a timeout error, try splitting the file into smaller files and adding them."},{"ref":"NotQwerty123.WordlistManager.html#query/2","title":"NotQwerty123.WordlistManager.query/2","type":"function","doc":"Search the wordlist to see if the password is too common. If the password is greater than 24 characters long, this function returns false without performing any checks."},{"ref":"NotQwerty123.WordlistManager.html#start_link/0","title":"NotQwerty123.WordlistManager.start_link/0","type":"function","doc":""}]